'****************************************************************
'*  Name    : Print_BUS_8Bits.BAS                               *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [----------]                   *
'*          : NO Right Reserved                                 *
'*  Date    : 05/01/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : Based on the code written by Les Johnson          *
'*          :                                                   *
'****************************************************************
'
' Demonstrate the replacement print routine with reversed bits
' For use with some Arduino shields on the Amicus18 board
'
' Header file for use with the Amicus18 board
' Use an 18F25K20 operating at 64MHz

    Include "Amicus18.inc"

'    Declare Create_Coff = On

'-------------------------------------------------------------------------------
'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial_RCSTA  = %10010000      ' Enable continuous receive 
'    Declare Hserial_TXSTA  = %00100100      ' Enable transmit, BRGH = 1
'    Declare Hserial_Clear  = On             ' Clear overflow automatically
'    Declare Hserial_SPBRG  = $82            ' Baud Rate Generator Low Byte Value
'    SPBRGH         = $06                    ' Baud Rate Generator High Byte Value
'    BAUDCON.3      = 1                      ' Enable the 16 bit Baud Rate Generator
'-------------------------------------------------------------------------------
' Setup the LCD. These must be included in the program

    Declare LCD_DTPin = PORTB.0
    Declare LCD_RSPin = PORTA.1
    Declare LCD_ENPin = PORTA.0
    Declare LCD_Interface = 8
    Declare LCD_Lines = 2
    Declare LCD_Type = Alphanumeric
    Declare LCD_CommandUs = 2000
    Declare LCD_DataUs = 50
    $define LCD_Reverse_Bits   
'-------------------------------------------------------------------------------
    Include "D:\MyIncFiles\LCD_Hitachi.inc" ' Load the replacement "reversed or normal" Print command for an 8-bit AND 4-Bit interface
'-------------------------------------------------------------------------------

    Dim wLoop As Word = 0
    
'-------------------------------------------------------------------------------
Main:
' Init ports
    PORTA = 0
    LATA = 0
    PORTB = 0
    LATB = 0    
    PORTC = 0
    LATC = 0
'    '   
'    ADCON0 = 0              ' Set all digital
'    ADCON1 = 0
'    ADCON2 = 0    
'    CM1CON0 = 0
'    CM2CON0 = 0
'    CM2CON1 = 0    
'    $if _device = _18F25K20
'    ANSEL = 0
'    ANSELH = 0
'    $endif
'    $if _device = _18F25K22
'    ANSELA = 0
'    ANSELB = 0
'    ANSELC = 0
'    $endif
$ifdef LCD_Reverse_Bits
    High LATA.2         ' Change multiplexer for reverse bits
$else
    Low LATA.2          ' Change multiplexer for normal bits
$endif
'-------------------------------------------------------------------------------
    HRSOut 1            ' Clear the terminal
    DelayMS 100                              ' Wait for the LCD to initialise            
    Cls
    DelayMS 100                              ' Wait for the LCD to initialise
$ifdef LCD_Reverse_Bits
    High LATA.2
    HRSOut "LCD TEST: PRINT PORT 8 Bits REVERSED",13
    Print "8Bits REVERSED"
$else
    Low LATA.2
    HRSOut "LCD TEST: PRINT PORT 8 Bits NORMAL",13
    Print "8Bits NORMAL"
$endif

    HRSOut "START",13
    
    While 1 = 1
        Print At 2,1,Dec wLoop, "  "
        Inc wLoop
        If wLoop = 999 Then
            wLoop = 0
        EndIf
        DelayMS 200
    Wend
'-------------------------------------------------------------------------------
    End
